// Copyright Epic Games, Inc. All Rights Reserved.

#include "AronaMain.h"
#include "UI/Style/AronaStyle.h"
#include "UI/AronaModuleCommands.h"

#include "Widgets/Docking/SDockTab.h"
#include "Widgets/Layout/SBox.h"
#include "Widgets/Text/STextBlock.h"


#define LOCTEXT_NAMESPACE "FAronaModule"

void FAronaMain::StartupModule()
{
	FAronaModuleCommands::Register();
	
	AppCommands = MakeShareable(new FUICommandList);
}

void FAronaMain::ShutdownModule()
{
	// This function may be called during shutdown to clean up your module.  For modules that support dynamic reloading,
	// we call this function before unloading the module.
	FAronaModuleCommands::Unregister();

	FGlobalTabmanager::Get()->UnregisterNomadTabSpawner(AronaModuleTabName);
}

#undef LOCTEXT_NAMESPACE
	
IMPLEMENT_MODULE(FAronaMain, AronaMain)
