﻿#pragma once
#include "Singleton/Singleton.h"

class FWaveform;

class FPeakFileManager : public TSingleton<FPeakFileManager>
{
public:
	virtual void Init() override;


	void LoadPeakFile(const FString& Path);
	void LoadCache();
	
	void GenerateCache();

	static FString GetCacheDirPath();
	static FString GetCacheDirMapFilePath();
private:
	void GenerateCacheTask();
	std::atomic_bool Processing = false;
	
	TMap<uint64, FWaveform*> WaveformMap;
};
