﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "SCompoundWidget.h"

class SMenuAnchor;
class FPluginHost;
/**
 * 
 */
class ARONA_API SMixerEffectItem : public SCompoundWidget
{
public:
	SLATE_BEGIN_ARGS(SMixerEffectItem)
		{}
	SLATE_END_ARGS()

	/** Constructs this widget with InArgs */
	void Construct(const FArguments& InArgs, FPluginHost* InPluginHost);

	virtual FReply OnMouseButtonUp(const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) override;
	FPluginHost* PluginHost;
private:
	FReply OnButtonClicked();
	FReply OnChannelInterfaceClicked();
	TSharedRef<SWidget> CreateChannelInterfaceMenu();

	void ShowMenu();

	TSharedPtr<SMenuAnchor> MenuAnchor;
};
