﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "SCompoundWidget.h"
#include "SPatternThumbnail.h"

class SUpdatableImage;
struct FImageData;
/**
 * 
 */
class ARONA_API SMidiPatternThumbnail : public SPatternThumbnail
{
public:
	~SMidiPatternThumbnail();
	SLATE_BEGIN_ARGS(SMidiPatternThumbnail)
	{
	}
	SLATE_END_ARGS()
	/** Constructs this widget with InArgs */
	void Construct(const FArguments& InArgs);
	virtual void Redraw() override;
protected:
	void OnPatternChanged(FPattern* OldPattern, FPattern* NewPattern);
private:
	void OnChanged(FPluginHost* Host, FMidiMessageSequence* Changed);
	void UpdateMidiThumbnail(FImageData& ImageData);

	TSharedPtr<SUpdatableImage> UpdatableImage;
};
