﻿#include "PianoRollEditTool.h"

#include "PluginHost/PluginHost.h"

void FPianoRollEditTool::OnActive(FPianoRollEdit& Edit)
{
	PluginHost = Edit.GetPluginHost();
}

void FPianoRollEditTool::Clear(FPianoRollEdit& Edit)
{
	PluginHost = nullptr;
}

void FPianoRollEditTool::PlaySelected(FPianoRollEdit& Edit)
{
	if (!PluginHost)
		return;
	
	TArray<int32> Notes;
	for (const FMidiMessageSequence::MidiEventHolder* Selected : Edit.Selector.GetSelectedMidiMessages())
	{
		if (!Selected->noteOffObject)
			continue;
		if (Notes.Contains(Selected->message.getNoteNumber()))
			continue;
			
		FMidiMessage NoteOn = Selected->message;
		FMidiMessage NoteOff = Selected->noteOffObject->message;
		Notes.Add(NoteOn.getNoteNumber());
			
		PluginHost->IncomingMidi.addEvent(NoteOn, 0);
		PluginHost->IncomingMidi.addEvent(NoteOff, 0);
	}
}

void FPianoRollEditTool::StopSelected(FPianoRollEdit& Edit)
{
	if (!PluginHost)
		return;
	
	TArray<int32> Notes;
	for (const FMidiMessageSequence::MidiEventHolder* Selected : Edit.Selector.GetSelectedMidiMessages())
	{
		if (!Selected->noteOffObject)
			continue;
		if (Notes.Contains(Selected->message.getNoteNumber()))
			continue;
			
		FMidiMessage NoteOff = Selected->noteOffObject->message;
		Notes.Add(Selected->message.getNoteNumber());
			
		PluginHost->IncomingMidi.addEvent(NoteOff, 0);
	}
}
