﻿#pragma once
#include "Reply.h"
#include "WidgetStyle.h"
#include "UI/Widget/PianoRoll/PianoRollPanel/PianoRollEdit.h"

class FPianoRollEditTool
{
public:
	FPianoRollEditTool(EPianoRollToolType InToolType) : PluginHost(nullptr), ToolType(InToolType)
	{
	}

	virtual ~FPianoRollEditTool() = default;

	virtual void OnActive(FPianoRollEdit& Edit);
	virtual void Clear(FPianoRollEdit& Edit);

	virtual void OnMouseButtonDown(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }
	virtual void OnMouseButtonUp(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }
	virtual void OnMouseMove(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }

	virtual void OnBeginDrag(FPianoRollEdit& Edit, FVector2f InMouseStartPos) { }
	virtual void OnEndDrag(FPianoRollEdit& Edit, FVector2f InMouseEndPos) { }

	virtual int32 OnPaint(const FPianoRollEdit& Edit, const FPaintArgs& Args, const FGeometry& AllottedGeometry, const FSlateRect& MyCullingRect, FSlateWindowElementList& OutDrawElements, int32 LayerId, const FWidgetStyle& InWidgetStyle, bool bParentEnabled) const { return LayerId; }
	
	EPianoRollToolType GetToolType() const { return ToolType; }
	FPluginHost* GetPluginHost() const { return PluginHost; }
protected:
	void PlaySelected(FPianoRollEdit& Edit);
	void StopSelected(FPianoRollEdit& Edit);
private:
	FPluginHost* PluginHost;
	EPianoRollToolType ToolType;
};
