﻿#pragma once
#include "PianoRollEditTool.h"

class FPianoRollEditTool_Write : public FPianoRollEditTool
{
public:
	FPianoRollEditTool_Write();

	virtual void OnActive(FPianoRollEdit& Edit) override;
	virtual void Clear(FPianoRollEdit& Edit) override;

	virtual void OnMouseButtonDown(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) override;
	virtual void OnMouseButtonUp(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) override;
	virtual void OnMouseMove(FPianoRollEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) override;
	
	int32 Channel;
	float Velocity;
	int64 NoteLength;
private:
	void OnMidiMessageSelected(FMidiMessageSequence::MidiEventHolder* MidiEventHolder);
	void OnMidiMessageUnSelected(FMidiMessageSequence::MidiEventHolder* MidiEventHolder);

	void PlayNote(int32 Note);
	void StopNote(int32 Note);

	void LeftMouseButton(FPianoRollEdit& Edit);
	void RightMouseButton(FPianoRollEdit& Edit);

	void UpdateTempSelector(FPianoRollEdit& Edit, int32 NewNote, MidiTick NewTick);
	void UpdateSelector(FPianoRollEdit& Edit, int32 NewNote, MidiTick NewTick);

	bool HasDeleteNote = false;

	FPianoRollSelector TempSelector;
};
