﻿#pragma once
#include "PaintArgs.h"
#include "Reply.h"
#include "WidgetStyle.h"
#include "UI/Widget/PlayList/PlayListPanel/PlayListEdit.h"

class FPlayListEditTool
{
public:
	FPlayListEditTool(EPlayListToolType InToolType) : ToolType(InToolType)
	{
	}

	virtual ~FPlayListEditTool() = default;

	virtual void OnActive(FPlayListEdit& Edit);
	virtual void Clear(FPlayListEdit& Edit);

	virtual void OnMouseButtonDown(FPlayListEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }
	virtual void OnMouseButtonUp(FPlayListEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }
	virtual void OnMouseMove(FPlayListEdit& Edit, const FGeometry& MyGeometry, const FPointerEvent& MouseEvent) { }

	virtual void OnBeginDrag(FPlayListEdit& Edit, FVector2f InMouseStartPos) { }
	virtual void OnEndDrag(FPlayListEdit& Edit, FVector2f InMouseEndPos) { }

	virtual int32 OnPaint(const FPlayListEdit& Edit, const FPaintArgs& Args, const FGeometry& AllottedGeometry, const FSlateRect& MyCullingRect, FSlateWindowElementList& OutDrawElements, int32 LayerId, const FWidgetStyle& InWidgetStyle, bool bParentEnabled) const { return LayerId; }
	
	EPlayListToolType GetToolType() const { return ToolType; }
private:
	EPlayListToolType ToolType;
};
