﻿#include "FTrackHeightManager.h"

int32 FTrackHeightManager::GetTrackIndexAt(float Height) const
{
	float ModifyHeight = 0;
	int32 ModifyCount = 0;
	for (const auto& ModifyTuple : ModifyTrackHeight)
	{
		if (Height >= ModifyTuple.Value)
		{
			ModifyCount++;
			ModifyHeight += ModifyTuple.Value;
		}
	}
	const float NoModifyHeight = Height - ModifyHeight;
	const int32 Index = NoModifyHeight / TrackHeight.Get() + ModifyCount;
	return Index;
}

float FTrackHeightManager::GetTrackHeight(int32 TrackIndex) const
{
	const float* Find = ModifyTrackHeight.Find(TrackIndex);
	if (Find)
		return *Find;
	return TrackHeight.Get();
}

float FTrackHeightManager::GetTrackPos(int32 TrackIndex) const
{
	const float NormalTrackHeight = TrackHeight.Get();
	const TArray<int32>& ModifyBeforeTrackIndex = GetModifyBeforeTrackIndex(TrackIndex);
	float Pos = (TrackIndex - ModifyBeforeTrackIndex.Num()) * NormalTrackHeight;
	
	for (int32 i = ModifyBeforeTrackIndex.Num() - 1; i >= 0; --i)
	{
		const int32 Index = ModifyBeforeTrackIndex[i];
		const float Find = ModifyTrackHeight[Index];
		Pos += Find;
	}

	return Pos;
}

TArray<int32> FTrackHeightManager::GetModifyBeforeTrackIndex(int32 TrackIndex) const
{
	TArray<int32> Result;
	for (const auto& Pair : ModifyTrackHeight)
	{
		if (Pair.Key >= TrackIndex)
			break;
		Result.Add(Pair.Key);
	}
	return Result;
}
