﻿#pragma once
#include "CoreMinimal.h"
#include "AudioBuffer/ChannelInterface.h"
#include "Midi/MidiMessageSequence.h"

class FMidiEvent;
class FMixerTrack;


class FPluginHost
{
public:
	FPluginHost();
	virtual ~FPluginHost();

	virtual bool Load(const FString& Path) { return false; }

	virtual void SetEnabled(bool bEnabled) {}
	virtual bool IsEnabled() { return false; }
	
	virtual void UpdateSampleRate(float SampleRate) {}
	virtual void UpdateBlockSize(int32 BlockSize) {}
	virtual int32 GetInputChannelNum() { return 0; }
	virtual int32 GetOutputChannelNum() { return 0; }
	virtual void UpdateChannelNodeName() {}

	virtual void Process(int32 FrameNum) {}
	
	virtual void OpenEditor(void* Handle) {}
	virtual void CloseEditor() {}
	virtual void ToggleEditor();
	virtual void IdleEditor() {}
	virtual bool HasEditor() { return false; }
	virtual FVector2D GetEditorSize() { return {}; }
	
	FString Name;
	FName Vendor;
	FChannelInterface* ChannelInterface;
	TArray<FMixerTrack*> OwnerTracks; // 该插件所属的轨道(乐器类型插件可能会有多个，效果器类型插件只有一个)
	FMidiMessageSequence IncomingMidi;
};
