#pragma once
#include "CoreMinimal.h"

typedef float SampleType;
#define SAMPLE_TYPE_FORMAT paFloat32

enum class EHostApiID
{
	InDevelopment = 0, /* use while developing support for a new host API */
	DirectSound = 1,
	MME = 2,
	ASIO = 3,
	SoundManager = 4,
	CoreAudio = 5,
	OSS = 7,
	ALSA = 8,
	AL = 9,
	BeOS = 10,
	WDMKS = 11,
	JACK = 12,
	WASAPI = 13,
	AudioScienceHPI = 14,
	AudioIO = 15
};

struct FAudioDeviceInfo
{
	FString Name;
	int32 DeviceIndex;
	int32 MaxInputChannels;
	int32 MaxOutputChannels;
	float DefaultSampleRate;
};

struct FAudioHostInfo
{
	FString Name;
	EHostApiID ID;
	int32 DeviceCount;
	int32 DefaultInputDevice;
	int32 DefaultOutputDevice;
};
